## Supported Audio formats on different platforms

Note that on most platforms, cocos2d-x invokes different SDK API for background music (BGM) and Effects. CocosDenshion can play ONLY ONE background music at one time, but can play many effects synchronously.

### Background Music

| Platforms | supported BGM formats|
|------------|-----------------------------|
| Android   |  formats that android.media.MediaPlayer support.|
| iOS          | It supports the same formats as CocosDenshion in cocos2d-iphone. MP3 and CAF are recommended|
| Windows Desktop | .mid and .wav are supported. Note that mp3 is not supported.|


### Sound Effects

| Platform | supported sound effects formats|
|-----------|---------------------------------------|
| Android  | Supports .ogg best, not so good for .wav format.|
| iOS         | .mp3, .wav, .caf |
| Windows Desktop | .mid and .wav only|

> WARNING: Samsung i9100 seems have a bug in its audio driver. It CAN NOT accept too much effects concurrently. You need to limit calling `SimpleAudioEngine::playEffect(const char* filePah)` too frequently in your game logic code when running on Samsung i9100.