Build HelloWorld on android x86 platform
========================================

NDK supports x86 platform from ndk-r6, but it has a bug. You can not build x86 and armxxx into one apk.
For example, you can not write like this in Application.mk:

    APP_ABI := armeabi x86

**ndk-r6b** fixes the bug, so use it.

### Build HelloWorld

1. Support x86 only
Change the APP\_ABI in HelloWorld/android/jni/Application.mk

     APP_ABI := x86 

2. Support x86 and armxxx
Change the APP\_ABI in HelloWorld/android/jni/Application.mk

     APP_ABI := armeabi armeabi-v7a x86 

### What is the APP\_ABI mean

When you define APP\_ABI in Application.mk, you tell ndk how many architectures can the apk support.
For example, APP\_ABI is armeabi and x86, then the apk can be installed on the phones which architecture
is arm or x86.

More information please refer NDK/docs/APPLICATION-MK.html and NDK/docs/CPU-ARCH-ABIS.html.
