**Coco Studio**
===============

![](http://www.cocos2d-x.org/attachments/download/2053)

{{toc}}

Downloads
---------

-   CocoStudio, [Download v0.1.3 ](http://upyun.cocimg.com/CocoStudio/520/CocoStudio.exe)

Highlights:
 UI Editor:
 1. Supported dragging structure tree .
 2. Modified the control position problem when dragging the structure tree.
 3. Modified the control layer problem when dragging the structure tree.
 4. Improved the control operation mode of doing the same scale zoom in the render zone.

Animation Editor:
 1.Modified not Finding the resource of exporting the project which picture resources have several different suffix.
 2.Modified losing the fame when undoing the frame of animation and skeleton
 3.Supported saving the states in the structure tree after changing the layer level.
 4.Supported pasting skeleton after copying skeleton.
 5. Supported stopping playing the animation when opening the project animation.
 6. Improved the layer operation mode of doing the same scale zoom in the render zone.

Start Page:
 1. Added the vision number.
 2. Added the BBS link and update the manual.
 3. Supported automatically updating.

-   CocoStudio GUIParser for Cocos2d-x, [CocoGUILIB v0.1.3](http://upyun.cocimg.com/CocoStudio/CocoStudioGUI_v0.1.3.zip)

Highlights:
 1. Added support for display the progress render node of Slider.
 2. Added support for setting character max length of TextField
 3. Added support for setting is displayed in the form of password of TextField
 4. Added support for open when the Scrollview is rebound effect of drag to the boundary.
 5. Added set berth orientation, berth event callback function on dragging ScrollView when Scrollview children size is smaller than Scrollview size of Scrollview.
 6. Added scroll to boundary event callback function of ScrollView.
 7. Added a new widget CocoImageButton.
 8. Support screen dynamic creation of control adapter.

-   CocoStudio Armature-Parser for Cocos2d-x, [Armature v0.1.3](http://upyun.cocimg.com/CocoStudio/Armature_v0.1.3.zip)

Highlights:
 1. Adds support for .ExportJson file format.
 2. Fix animation pause(), resume() bug.
 3. Remove using namespace cocos2d from .h header.
 4. Remove ComArmature interface.
 5. Fix set bone rotation bug.
 6. Fix do not set bone TransformDirty to false after bone update.

Note that the softwares below are required for CocoStudio, you should install them before using CocoStudio:
\# Microsoft Visual C++ 2010 SP1 Redistributable, [32-bit](http://www.microsoft.com/download/details.aspx?id=8328), [64-bit](http://www.microsoft.com/download/details.aspx?id=13523)
\# [Microsoft .NET Framework 4 Client Profile](http://www.microsoft.com/download/details.aspx?id=24872)
\# [Microsoft Access Database Engine 2010 Redistributable](http://www.microsoft.com/download/details.aspx?id=13255)

For more details, please check the [[Changelogs of CocoStudio]].

About
-----

CocoStudio is a game development tool kit based on Cocos2d-x. It breaks down tasks in game development into different roles, it includes:
\* UI editor for UI graphic artists,
\* Animation editor for graphic artists,
\* Number cruncher for game data designers,
\* Scene editor for game designers

CocoStudio forms a complete game development solution.

### The UI editor

The UI was designed to serve its only purpose: create UI for games.
Its simple and intuitive interface allows graphic artists to focus on their expertise, without worrying about other aspects such as programming.

Currently the UI editor has 12 different UI elements ready to be used in games, new UI elements will be added with each and every release of CocoStudio,

Other key features that the UI editor supports are:
\* Texture packaging - Automatically packs individual texture files into a single large sprite, which further saves memory and improves game performance.
\* Multi-resolution adaption - Automatically adapts to multiple resolution sizes with relative UI positioning.
\* Templating - Reuse the same UI layout across different games, swap out texture resources to give it a new look.

### The Animation editor

The Animation editor was designed to feel like Adobe Flash, which makes graphic artists feel right at home.
The Animation editor brings skeletal animation to Cocos2d-x.
What advantage does skeletal animation holds against the traditional frame animation?
\* Lower memory consumption - An animation with the traditional frame based solution could use dozens of individual textures, but with skeletal animation, only 1 set of body parts is required to make infinite number of different animations.
\* Smaller file size - due to less number of assets.
\* Animation blending - you can combine animations together to easily make new animation, for example, you could blend attacking animation with walk animation to create attacking while walking animation.
\* Animation reuse - you can share skeletal animations with another character with the same skeleton setup.
\* Smooth interpolation - traditional frame based animation is very choppy especially in slow motion. Skeletal animation interpolates between 2 sets of key frames, so animation is always played at the same frame rate as the game.

However Skeletal animation cannot replace the traditional frame based animation, for example, it cannot make isometric character, it cannot make explosion, that is why we did not forget frame based animation, we even made it better and simpler. You only have to drag and drop frame sequences to the work space, and the animation editor will automatically creates the frame animation for you.

Other highlight of Animation editor includes:
\* WYSIWYG collision box editing - editing collision box in wysiwyg way has never being easier and accurate.
\* Reference point - enables characters to wield swords, mount horses, and attaching other objects easily.
\* Texture packing - Automatically packs individual texture files into a single large sprite, which further saves memory and improves game performance.

### The Data Cruncher

The data Cruncher imports excel tables and converts the data into a format readable by cocos2d-x, which can also be used as a component for the Scene editor.

### The Scene editor

The scene editor pieces all the assets made by the UI editor, Animation editor, and the Data Cruncher into a game scene, it can then simulate the game inside the editor.
The scene editor also supports many assets made from third party editors such as particle designer, tiled etc.

The scene editor relies on the CocosStudio Framework.

### CocoStudio Framework

CocoStudio Framework is an open source higher level framework on top of Cocos2d-x, it employes entity and component system, it is used to read the data saved from the scene editor.
The Scene editor saves data in a MVC like fashion, it includes all entities and events used in the current scene, and exports to corresponding code template for the programmers.
A programmer can then write the code in Javascript to bring the game alive.

Contact Us
----------

URL : http://studio.cocos2d-x.org
email : cocostudio@chukong-inc.com
weibo: `cocos2d-x

h2. Please note

1. CocoStudio is still in its EARLY STAGE version, so it may contain bugs and errors.
2. Please use Administrator privilege to start the executable files if the editors can't launched properly.
3. Microsoft .Net Framework 4.0 is required. (Download: http://www.microsoft.com/en-US/download/details.aspx?id=17718)
4. The program is for Windows only
5. Turn your tunes on, more documents, tutorials, videos are coming soon.

?????

1. ????????????????????bug?????????????????????
2. ?????Windows??????????????????????????????????????????
3. ?????.Net Framework 4.0???????????????(?????http://www.microsoft.com/zh-cn/download/details.aspx?id=17718 )
4. ????????Windows???
5. ????????????????????

??????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????+???????????????github????????????????????????????????????

For bug reports, please send email to: cocostudio`chukong-inc.com

Forum: http://bbs.cocostudio.org/ (Mandarin only)
