Cocos Code IDE
========

![](http://www.cocos2d-x.org/attachments/download/5337)

{{toc}}

Overview
----------
[This product page](http://ide.cocos2d-x.org) covers the key features of Cocos Code IDE.
Cocos Code IDE is the complete toolkit for developing, debugging, publishing cocos2d-x Lua & JavaScript games. It can work together with Cocos2d-x v3.x, Cocos2d-js v3.x and higher versions.
	
Download
----------
Cocos Code IDE can only work together with Cocos2d-x 3.x and Cocos2d-js 3.x engines.

For Microsoft Windows users, please firstly check your java version by command `java -version` in your console. It will output like this. 

```
	java version "1.6.0_65" 
	Java(TM) SE Runtime Environment (build 1.6.0_65-b14-462-11M4609) 
	Java HotSpot(TM) 64-Bit Server VM (build 20.65-b04-462, mixed mode) 
```
You can know if your Java is **32-Bit** or **64-Bit** from this output, then download corresponding version of IDE. If you haven't installed `java`, please download and install [JDK][JDK link] first.
For Mac users, we only provide 64-Bit for now.

---
**Cocos Code IDE compatible with Cocos2d-x: **

| IDE\Cocos2d-x | 3.2 Final | 3.3 rc0 | 3.3 rc1 | 3.3 final |
| ------------- |:---------:| :------:| :------:|:---------:|
| 1.1.0 		| ? 		 | ?       | ?       | ?         |
| 1.0.2 		| ? 		 | ?       | ?       | x         |
| 1.0.1 		| ? 		 | ?       | x       | x         |
| 1.0.0-Final 	| ? 		 | ?       | x       | x         |
| 1.0.0-RC2   	| ? 		 | x       | x       | x         |

---
**Cocos Code IDE compatible with Cocos2d-js: **

| IDE\Cocos2d-x | 3.0 Final | 3.1 Final | 3.2 rc0 |
| ------------- |:---------:| :--------:| :------:|
| 1.1.0 		| ? 		 | ?         | ?       |
| 1.0.2 		| ? 		 | ?         | x       |
| 1.0.1 		| ? 		 | ?         | x       |
| 1.0.0-Final 	| ? 		 | ?         | x       |
| 1.0.0-RC2   	| ? 		 | x         | x       |

Please download right version form [Cocos Download page][cocos download page].

Install
------------

### Basic Requirements:

+ **[Windows users]** Install [Python 2.7.x][Python link]. Mac OS X users can skip this step because the operating system has integrated Python 2.7.
* **Don't put IDE in a directory that the path include non-English characters**

### Additional Requirements:

* For debugging on iOS simulator, please make sure iOS simulator has been installed.
* For debugging on android device through USB cable, please make sure [Android SDK][Android SDK link] has been installed.
* If you want to customize a runtime, you need compilation tools for your target platform:

    | Target Platform      | Tools |
    | ------------- |:----------------------------:|
    | Mac OS X/iOS  | XCode 5.1 or above|
    | Windows       | VS2012 or above|
    | Android       | [Android SDK][Android SDK link], [NDK (**R9D version**)][NDK link], [ANT][ANT link] |
    
### Developing your existing game by Code IDE

If your game is using Cocos2d-x 3.x or Cocos2d-js 3.x, you can easily include IDE into the process. All you need to do is:
* New a Cocos Lua/JavaScript project
* Replace the the resouces and Lua/JavaScipt by your own
    
How to Use
----------

+ [[How to Debug Cocos2d-x Lua Game Using Code IDE]]
+ [[How to Debug Cocos2d-x JS Game Using Code IDE]]
+ [[How to debug the C++ with script side-by-side simultaneously]]
+ [[How to build a simple game with Cocos Code IDE]]

[JDK link]: http://www.oracle.com/technetwork/java/javase/downloads/index.html 
[Android SDK link]: https://developer.android.com/sdk/index.html?hl=sk
[NDK link]: https://developer.android.com/tools/sdk/ndk/
[ANT link]: http://ant.apache.org/
[Python link]: http://www.python.org/download
[cocos download page]: http://download.cocos2d-x.org