EditBox
=======

{{toc}}

## Introduction
------------

EditBox is a wrapper  of system control for user input. Its an subclass of cocos2d::ui::Widget. You can use this widget to gather small chunk of text from the user on iOS, Android, Mac, Windows and WP8.  

Editbox does not support line breaks and wrapping, which means that Editbox only can be used for single line text. It can't be used as TextArea for displaying multiline text.

## How to use

The usage of EditBox is very easy since you only need a few lines of code as bellow.

### Create  an EditBox for normal text input

```cpp
       std::string pNormalSprite = "extensions/green_edit.png";
        _editName = ui::EditBox::create(editBoxSize, ui::Scale9Sprite::create(pNormalSprite));
        _editName->setPosition(Vec2(visibleOrigin.x+visibleSize.width/2, visibleOrigin.y+visibleSize.height*3/4));
        _editName->setFontName("Paint Boy");
        _editName->setFontSize(25);
        _editName->setFontColor(Color3B::RED);
        _editName->setPlaceHolder("Name:");
        _editName->setPlaceholderFontColor(Color3B::WHITE);
        _editName->setMaxLength(8);
        _editName->setReturnType(ui::EditBox::KeyboardReturnType::DONE);
        _editName->setDelegate(this);
        addChild(_editName);
```

![](http://www.cocos2d-x.org/attachments/download/5620)

### Create an EditBox for password input
```cpp
       _editPassword = ui::EditBox::create(editBoxSize, "extensions/orange_edit.png");
        _editPassword->setPosition(Vec2(visibleOrigin.x+visibleSize.width/2, visibleOrigin.y+visibleSize.height/2));
        _editPassword->setFont("American Typewriter", 80);
        _editPassword->setFontColor(Color3B::GREEN);
        _editPassword->setPlaceHolder("Password:");
        _editPassword->setMaxLength(6);
        _editPassword->setInputFlag(ui::EditBox::InputFlag::PASSWORD);
        _editPassword->setInputMode(ui::EditBox::InputMode::SINGLE_LINE);
        _editPassword->setDelegate(this);
        addChild(_editPassword);
```

![](http://www.cocos2d-x.org/attachments/download/5621)
### Create an EditBox for email input
```cpp
       _editEmail = ui::EditBox::create(Size(editBoxSize.width, editBoxSize.height), "extensions/yellow_edit.png");
         _editEmail->setPosition(Vec2(visibleOrigin.x+visibleSize.width/2, visibleOrigin.y+visibleSize.height/4));
        _editEmail->setAnchorPoint(Vec2(0.5, 1.0f));
        _editEmail->setPlaceHolder("Email:");
        _editEmail->setInputMode(ui::EditBox::InputMode::EMAIL_ADDRESS);
        _editEmail->setDelegate(this);
        addChild(_editEmail);
```

![](http://www.cocos2d-x.org/attachments/download/5622)