Facebook API Reference in JavaScript
=====================================

> version: cocos2d-js v3.x
> update: {{lastupdated_at}}

{{toc}}

##FacebookAgent class

`plugin.FacebookAgent` is a singleton class that encapsulates all the methods. Before doing anything else, you need to initialize the instance first.

##Core Methods

|Name|Description|
|----|-----------|
|[getInstance](http://cocos2d-x.org/wiki/Facebook-getInstance) |Initialize the SDK, and return the instance of `plugin.FacebookAgent`. Required before doing anything else.|
|[destroyInstance](http://cocos2d-x.org/wiki/Facebook-destroyInstance) |Destroy the instance of `plugin.FacebookAgent`.|
|[api](http://cocos2d-x.org/wiki/Facebook-graph-api) |Call the [Facebook Graph API](http://developers.facebook.com/docs/graph-api) to find out about the user or act on his/her behalf.|
|[dialog](http://cocos2d-x.org/wiki/Facebook-dialog) |Trigger different forms of Facebook created UI dialogs, such as the Share Dialog for one-to-many sharing on Facebook, or the Message Dialog for sending messages to friends. |
|[canPresentDialog](http://cocos2d-x.org/wiki/Facebook-canPresentDialog) | Check whether it can trigger a particular form of Facebook created UI dialog based on the current user's device environment.|
|[appRequest](http://cocos2d-x.org/wiki/Facebook-appRequest) |Trigger the [Request](http://developers.facebook.com/docs/reference/dialogs/requests/) dialog to send a request to one or more of friends from a game.|

##Auth and Session Methods

|Name|Description|
|----|-----------|
|[login](http://cocos2d-x.org/wiki/Facebook-login) |Ask a user to authorize your app, or to grant additional authorizations.|
|[logout](http://cocos2d-x.org/wiki/Facebook-logout) |Log a user entirely out of Facebook.|
|[isLoggedIn](http://cocos2d-x.org/wiki/Facebook-isLoggedIn) | Check whether a user is currently logged in and has authorized your app.|
|[getUserId](http://cocos2d-x.org/wiki/Facebook-getUserId) |Get the Facebook user ID of the currently logged in user.|
|[getAccessToken](http://cocos2d-x.org/wiki/Facebook-getAccessToken) |Get the access token granted to your application by current user.|

##Auxiliary Methods

|Name|Description|
|----|-----------|
|[canvas.pay](http://cocos2d-x.org/wiki/Facebook-canvaspay) |Prompt the user to make a payment using [Facebook Payments](http://developers.facebook.com/docs/concepts/payments/). _Desktop only_.|
|[activateApp](http://cocos2d-x.org/wiki/Facebook-activateApp) |Report the launch of the app, for integration with Facebook app ads. More details at [App Events](http://developers.facebook.com/docs/platforminsights/appevents). |
|[logEvent](http://cocos2d-x.org/wiki/Facebook-logEvent) | Report an app event, for integration with Facebook app ads. More details at [App Events](http://developers.facebook.com/docs/platforminsights/appevents). |
|[logPurchase](http://cocos2d-x.org/wiki/Facebook-logPurchase) | Report a purchase event, for integration with Facebook app ads. More details at [App Events](http://developers.facebook.com/docs/platforminsights/appevents). |

##Facebook API availability on different platforms

|Methods|iOS|Android|Web|
|:-:|:-:|:-----:|:-:|
|api|?|?|?|
|dialog - shareLink|?|?|?|
|dialog - shareOpenGraph|?|?|?|
|dialog - sharePhoto|?|?|×|
|dialog - messageLink|?|?|?|
|dialog - messageOpenGraph|?|?|×|
|dialog - messagePhoto|?|?|×|
|dialog - feedDialog|?|?|?|
|appRequest|?|?|?|
|login|?|?|?|
|logout|?|?|?|
|isLoggedIn|?|?|?|
|getUserId|?|?|?|
|getAccessToken|?|?|?|
|canvas.pay|×|×|?|
|activateApp|?|?|?|
|logEvent|?|?|?|
|logPurchase|?|?|?|