Getting Started with Cocos2d-JS
===================================

Introduction
------------

Cocos2d-JS is the latest spin off from Cocos2d-X team. It is written in Javascript for HTML5 compliant browsers and Cocos2d-x JavaScript Bindings (JSB). The API is derived from Cocos2d-X, therefor if you have any experience in Cocos2d game engines, you already know how to use Cocos2d-html5. If you never used Cocos2d game engine before, dont worry, this article will teach you everything you need to know to get started.

Cocos2d-JS includes Cocos2d-html5 and Cocos2d-x JSB. Because Cocos2d-html5 is based on web,  you can write your app on any platform as long as you have access to a text editor, and because its web based, your app can be run on any device that have access to a web browser (HTML5 compliant one)! How convenient, and that is why, The future is in your browser.
![](http://cocos2d-x.org/attachments/4697/Cocos2d-JS%20Structure-2.png)

Cocos2d-JS provides a consistent development experience for whichever platform you want to distribute to, both web and native. "Code once, run everywhere" is incredibly easy and natural in Cocos2d-JS. With one single javascript code base, you can run your game on both web browsers and native platform including Mac OS, Windows, iOS, Android. This will bring your game great opportunities in almost all canals of distribution.

### Beginners Hands-on ###
- [[Folder Structure of Cocos2d-JS]]
- [How to create a new project of Cocos2d-JS](http://cocos2d-x.org/docs/manual/framework/html5/v2/cocos-console/en)
- [About Cocos2d-JS and documents](http://cocos2d-x.org/docs/manual/framework/html5/en)

#### Parkour Game Tutorials of Cocos2d-JS v3.x  ####
- [Cocos2d-JS tutorial 1: Setting up Cocos2d-JS Development Environment](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter1/en)
- [Cocos2d-JS tutorial 2: Hello World Cocos2d-JS](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter2/en)
- [Cocos2d-JS Tutorial 3: Make Your First Game Scene](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter3/en)
- [Cocos2d-JS Tutorial 4: Design and Make Your Gameplay Scene](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter4/en)
- [Cocos2d-JS Tutorial 5: Let the Player Run Animations](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter5/en)
- [Cocos2d-JS Tutorial 6: Add Chipmunk Physic Engine to Our Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter6/en)
- [Cocos2d-JS Tutorial 7: Explorer with TiledMap and Display](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter7/en)
- [Cocos2d-JS Tutorial 8: Add Coin and Obstacles Into Our Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter8/en)
- [Cocos2d-JS Tutorial 9: Implement Game Over Logic and More](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter9/en)
- [Cocos2d-JS Tutorial 10: Add Audio Effect into Parkour Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript-v3.0/chapter10/en)

### New features and API changes in version 3.0 ###
- [New workflow with cocos console](http://cocos2d-x.org/docs/manual/framework/html5/v2/cocos-console/en)
- [Assets manager](http://cocos2d-x.org/docs/manual/framework/html5/v3/assets-manager/en)
- [New event manager](http://cocos2d-x.org/docs/manual/framework/html5/v3/eventManager/en)
- [New property API](http://cocos2d-x.org/docs/manual/framework/html5/v3/getter-setter-api/en)
- [Game creation](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-game/en)
- [Construction and inheritance](http://cocos2d-x.org/docs/manual/framework/html5/v3/inheritance/en)
- [Simplified Action APIs](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-actions/en)
- [Objects Pool](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-pool/en)
- [Bake Layer](http://cocos2d-x.org/docs/manual/framework/html5/v3/bake-layer/en)
- [Reflection from Javascript to JAVA](http://cocos2d-x.org/docs/manual/framework/html5/v3/reflection/en)
- [Reflection from Javascript to Objective-C](http://cocos2d-x.org/docs/manual/framework/html5/v3/reflection-oc/en)
- [Cocos2d-html5 modulization](http://cocos2d-x.org/docs/manual/framework/html5/v3/moduleconfig-json/en)
- [Pure configuration file](http://cocos2d-x.org/docs/manual/framework/html5/v3/project-json/en)
- [Basic data refactoration](http://cocos2d-x.org/docs/manual/framework/html5/v3/basic-data/en)
- [Singleton objects refactoration](http://cocos2d-x.org/docs/manual/framework/html5/v3/singleton-objs/en)
- [Loading resource with cc.loader](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-loader/en)
- [System information in cc.sys](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-sys/en)
- [Path management with cc.path](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-path/en)
- [Asynchronised process with cc.async](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-async/en)
- [Modification to cc.saxParser](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-saxparser/en)
- [Modification to cc.spriteFrameCache](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-spriteframecache/en)
- [About cc.log](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-log/en)
- [Other change from v2.2.2 to v3.0](http://cocos2d-x.org/docs/manual/framework/html5/v3/more-change-from-v2-to-v3/en)

### Advanced topics ###
- [Cocos2d-JS Remote Debugging by Firefox](http://cocos2d-x.org/docs/manual/framework/native/v3/js-remote-debugger/en)
- [[Understand the Resolution Policy in Cocos2d-html5 2.2.2]]
- [How to use extensions in JSB(Chinese version)](http://cocos2d-x.org/docs/manual/framework/html5/jsb/jsb-extension/zh)
- [How to use Plugin-x on Android](http://cocos2d-x.org/docs/manual/framework/html5/jsb/plugin-x/how-to-use-plugin-x-on-android/en)
- [Plugin-x architecture](http://cocos2d-x.org/docs/manual/framework/html5/jsb/plugin-x/plugin-x-architecture/en)
- [How to write your own Plugin for Android](http://cocos2d-x.org/docs/manual/framework/html5/jsb/plugin-x/how-to-write-your-own-plugin-for-android/en)
- [Use iOS IAP Plugin](http://cocos2d-x.org/docs/manual/framework/html5/jsb/plugin-x/ios-iap/en)

#### Parkour Game Tutorials of Cocos2d-html5 v2.2.x ####
- [Cocos2D HTML5 tutorial 1: Setting up Cocos2d-HTML5 Development Environment](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter1/en)
- [Cocos2D HTML5 tutorial 2: Hello World Cocos2d-HTML5](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter2/en)
- [Cocos2D HTML5 Tutorial 3: Make Your First Game Scene](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter3/en)
- [Cocos2D HTML5 Tutorial 4: Design and Make Your Gameplay Scene](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter4/en)
- [Cocos2D HTML5 Tutorial 5: Let the Player Run Animations](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter5/en)
- [Cocos2D HTML5 Tutorial 6: Add Chipmunk Physic Engine to Our Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter6/en)
- [Cocos2D HTML5 Tutorial 7: Explorer with TiledMap and Camera](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter7/en)
- [Cocos2D HTML5 Tutorial 8: Add Coin and Obstacles Into Our Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter8/en)
- [Cocos2D HTML5 Tutorial 9: Implement Game Over Logic and More](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter9/en)
- [Cocos2D HTML5 Tutorial 10: Add Audio Effect into Parkour Game](http://cocos2d-x.org/docs/tutorial/framework/html5/parkour-game-with-javascript/chapter10/en)

Conclusion
----------

Well I hope youve found this brief introduction to Cocos2d-JS helpful. And hope you feel that Cocos2d-JS is an easy to setup, easy to learn, and easy to use framework. You can finish your games efficiently with Cocos2d-JS, and run it cross browsers.

If youve enjoyed this let me know via Twitter: http://www.twitter.com/cocos2dx, its always good to say hello!