How to Use Custom TTF Font on iOS
=================================

## Overview
Cocos2d-x v3.x uses FreeType to draw customer TTF font  . But it also supports system TTF font.
But we highly recommend your to create a Label With TTF font support by using:

```
Label::createWithTTF
```

Instead of :

```
Label::createWithSystemFont
```

The system way is much slower than FreeType, So when you are using custom TTF font, be sure to call the correct functions.

## How to use
In order to use customer TTF font in your project, you should do some extra work. I will take TestCpp as an example.

* Add your custom font files into your project with XCode:
![](http://www.cocos2d-x.org/attachments/download/1282)

* Using the TTF font name to create a Label instance, then you could start to manipulate the TTF Label now.

Please refer to [tests/cpp-tests/Classes/LabelTest/LabelTestNew.cpp](https://github.com/cocos2d/cocos2d-x/blob/v3/tests/cpp-tests/Classes/LabelTest/LabelTestNew.cpp) for detail information.
