How to save/read file on different platforms
============================================

You can use standard c functions, such as fopen, fwrite, to save and read file on different platforms. Of cource, you can use other standard functions to operate with a file. The difficulty is the path to save or read a file.

This article modifies the HelloWorld example to show you how to save/read file on different platforms.

**Now, CCFileUtils::getWriteablePath returns a writeable path. You can use it to get the writeable path.**

1. Run example on different platforms
-------------------------------------

### 1.1 Android

-   Copy attachment:FileOperation.h and attachment:FileOperation.cpp into cocos2d-x/HelloWorld.
-   Invoke FileOperation::saveFile() and FileOperation::readFile() in HelloWorld::init().
-   Modify cocos2d-x/HelloWorld/android/jni/helloworld/Android.mk.
    ![](http://www.cocos2d-x.org/attachments/download/287)
-   Rebuild and run

You will see the log in eclipse like:
![](http://www.cocos2d-x.org/attachments/download/292)

Also, you can see the file content:
![](http://www.cocos2d-x.org/attachments/download/285)

### 1.2 iOS

-   Copy attachment:FileOperation.h and attachment:FileOperation.mm into cocos2d-x/HelloWorld.
-   Invoke FileOperation::saveFile() and FileOperation::readFile() in HelloWorld::init().
-   Add FileOperation.h and FileOperation into project file.
    ![](http://www.cocos2d-x.org/attachments/download/288)
-   Rebuild and run

You will see the log in eclipse like:
![](http://www.cocos2d-x.org/attachments/download/283)

Also, you can see the file content:
![](http://www.cocos2d-x.org/attachments/download/310)

Please reference to the apple document:
[iOS Aplication Programming Guide - File & the File system](http://developer.apple.com/library/ios/#documentation/iPhone/Conceptual/iPhoneOSProgrammingGuide/StandardBehaviors/StandardBehaviors.html#//apple_ref/doc/uid/TP40007072-CH4-SW6)
[CHN version](http://www.apple.com.cn/developer/iphone/library/documentation/iPhone/Conceptual/iPhoneOSProgrammingGuide/FilesandNetworking/FilesandNetworking.html)

### 1.3 Windows

-   Copy attachment:FileOperation.h and attachment:FileOperation.cpp into cocos2d-x/HelloWorld.
-   Invoke FileOperation::saveFile() and FileOperation::readFile() in HelloWorld::init().
-   Add FileOperation.h and FileOperation into project file.
    ![](http://www.cocos2d-x.org/attachments/download/289)
-   Rebuild and run

You will see the log in eclipse like:
![](http://www.cocos2d-x.org/attachments/download/291)

Also, you can see the file content:
![](http://www.cocos2d-x.org/attachments/download/284)

2. Summary
----------

This article just gives a guide of how to save/read file on different platforms. It is not the standard method,
just a workable method.
