# How to run cpp-tests on Linux #
===============================

## Environment Requirements ##
- Ubuntu 12.10+
- Cocos2d-x v3.0 ([https://github.com/cocos2d/cocos2d-x/](https://github.com/cocos2d/cocos2d-x/ "cocos2d-x"))
- CMake 2.6+
 
In this document, the variable `cocos2dx_root` means the root path of Cocos2d-x.  

* ## Install Dependencies ##

	The dependencies are:
````
		libx11-dev
		libxmu-dev
		libglu1-mesa-dev
		libgl2ps-dev
		libxi-dev
		g++
		libzip-dev
		libpng12-dev
		libcurl4-gnutls-dev
		libfontconfig1-dev
		libsqlite3-dev
		libglew*-dev
		libssl-dev
````
	If you are using Ubuntu/Debian, there is a shell script **_(build/install-deps-linux.sh)_** for you to install the dependences easily. Run commands below in terminal:  

    	$ cd $cocos2dx_root/build
    	$ ./install-deps-linux.sh

	Otherwise, you should install the dependencies manually.

* ## Generate Makefile

	Run `cmake` to generate `makefile`:

    	$ mkdir linux-build
    	$ cd linux-build
    	$ cmake ../..

	When `cmake` returns correctly, many files & folders will be generated in  `coocs2dx_root/build/linux-build`:
       ![folderImg](folderImg.jpg)
	
* ## Compile

	Run `make` to compile:

    	$ make

	Application will be generated in `cocos2dx_root/build/linux-build/bin/cpp-tests/` if compiled auccessfully.

* ## Run

		$ cd bin/cpp-tests/
		$ ./cpp-tests
	
	The Application should run like this:
        ![runningScene](runningScene.jpg)