Layer
=====

{{child_pages}}

Layer seems to useless since v3.0, because now all Nodes can receive touch events. `It is reserved just for compatibility. It may be removed in future`.

![](http://www.cocos2d-x.org/attachments/1592/layers.png)

Layers may contain any Node as a child, including Sprites, Labels, and even other Layer objects. Because layers are a subclass of Node, they can be transformed manually or by using Actions. See [[Actions]] for more information.

### Multiple Layers Example:

c++
```c++
auto layer1 = LayerGradient::create(Color4B(255, 0, 0, 255), Color4B(255, 0, 255, 255));
layer1->setContentSize(Size(80, 80));
layer1->setPosition(Vec2(50, 50));
addChild(layer1);

auto layer2 = LayerGradient::create(Color4B(0, 0, 0, 127), Color4B(255, 255, 255, 127));
layer2->setContentSize(Size(80, 80));
layer2->setPosition(Vec2(100,90));
addChild(layer2);

auto layer3 = LayerGradient::create();
layer3->setContentSize(Size(80, 80));
layer3->setPosition(Vec2(150,140));
layer3->setStartColor(Color3B(255, 0, 0));
layer3->setEndColor(Color3B(255, 0, 255));
layer3->setStartOpacity(255);
layer3->setEndOpacity(255);
BlendFunc blend;
blend.src = GL_SRC_ALPHA;
blend.dst = GL_ONE_MINUS_SRC_ALPHA;
layer3->setBlendFunc(blend);
addChild(layer3);
```

lua
```lua
local layer1 = cc.LayerGradient:create(cc.c4b(255, 0, 0, 255), cc.c4b(255, 0, 255, 255));
layer1:setContentSize(cc.size(80, 80));
layer1:setPosition(cc.p(50, 50));
addChild(layer1);

local layer2 = cc.LayerGradient:create(cc.c4b(0, 0, 0, 127), cc.c4b(255, 255, 255, 127));
layer2:setContentSize(cc.size(80, 80));
layer2:setPosition(cc.p(100,90));
addChild(layer2);

local layer3 = cc.LayerGradient:create();
layer3:setContentSize(cc.size(80, 80));
layer3:setPosition(cc.p(150,140));
layer3:setStartColor(cc.c3b(255, 0, 0));
layer3:setEndColor(cc.c3b(255, 0, 255));
layer3:setStartOpacity(255);
layer3:setEndOpacity(255);
layer3:setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
addChild(layer3);
```

![multi-layers](multi-layers.png)