# Cocos2d-JS v3.0 beta release note

Cocos2d-JS is Cocos2d-x engine's javascript version which include Cocos2d-html5 and Cocos2d-x JavaScript Bindings. It support full Cocos2d-x features with a set of simplified javascript friendly APIs.

Cocos2d-JS provides a consistent development experience for whichever platform you want to distribute to, both web and native. "Code once, run everywhere" is incredibly easy and natural in Cocos2d-JS. With one single javascript code base, you can run your game on both web browsers and native platform including Mac OS, Windows, iOS, Android. This will bring your game great opportunities in almost all canals of distribution.

Furthermore, javascript friendly API makes your game development experience a breeze, easy to code, test and distribute. Cocos2d-JS also offers Cocos Console, a script tool, to simplify the creation of projects and let you start coding right away. You can use it to create a new project and publish it to android, iOS, Mac OS or web.

For more informations please see [Cocos2d-JS github site](https://github.com/cocos2d/cocos2d-js)

## Download

- [cocos2d-js-v3.0-beta.zip](http://www.cocos2d-x.org/filedown/cocos2d-js-v3.0-beta.zip)
- [Online API reference](http://www.cocos2d-x.org/reference/html5-js/V3.0beta/index.html)
- [Downloadable API Reference](http://www.cocos2d-x.org/filedown/Cocos2d-JS-v3.0-beta-API.zip)
- [For Web Development Only](http://www.cocos2d-x.org/jsbuilder)

## Highlights

* **[Beta Feature]** Added `AssetManager` for Cocos2d-x JSB asset hot updating, please refer to [AssetManager document](http://cocos2d-x.org/docs/manual/framework/html5/v3/assets-manager/en).  
* **[Beta Feature]** Enabled `Baseline compiler` of SpiderMonkey to boost the performance of JSB on Android, mostly it is **really faster than Lua**.
* **[Beta Feature]** Integrated `Spine` skeleton animation feature.
* **[Beta Feature]** Re-enable `Plugin-x` for third party SDK integration, please refer to [Plugin-x Architecture](http://cocos2d-x.org/docs/manual/framework/html5/v3/plugin-x/plugin-x-architecture/en), [How to use plugin-x in android](http://cocos2d-x.org/docs/manual/framework/html5/v3/plugin-x/how-to-use-plugin-x-on-android/en) and [How to write your own plugin for android](http://cocos2d-x.org/docs/manual/framework/html5/v3/plugin-x/how-to-write-your-own-plugin-for-android/en).
* **[Beta Feature]** Upgraded SpiderMonkey to `v28`.
* **[Beta Feature]** Implemented `reflexion` from Javascript to JAVA static class functions.
* **[Beta Feature]** Refactored `actions` to make it more friendly and easy-to-use, please refer to [new actions API](http://cocos2d-x.org/docs/manual/framework/html5/v3/cc-actions/en).

## More information ##

Read more about all the new features at [Cocos2d-JS v3.0 beta changelog](http://www.cocos2d-x.org/docs/manual/framework/html5/release-notes/v3.0b/changelog/en) and [Cocos2d-JS v3.0 beta upgrade guide](http://www.cocos2d-x.org/docs/manual/framework/html5/release-notes/v3.0a/upgrade-guide/en)