Scene Editor Rendering Panel
============================

Introduction
------------

![](http://www.cocos2d-x.org/attachments/download/3043)

The Render window provides a rendering control panel which displays a real-time effect preview.

Feature
-------

### Marquee

![](http://www.cocos2d-x.org/attachments/download/3044)

Use the mouse controls to copy, delete and create settings for the marquee.

### Adjusting the view

![](http://www.cocos2d-x.org/attachments/download/3045)

**Directions**:
\# At points 1,2,4,5, you can use the mouse to resize the component and retractable controls. Press and hold down the Shift key to geometrically scale.
\# Point 3 allows you to rotate the control.

**Note** : Use the above feature to mount the Node of Sprite component, UI component or Map component.

Right-Click Menu
----------------

### Add Object

![](http://www.cocos2d-x.org/attachments/download/3046)

Adding an object to the canvas
**Note** :
When you select a scene and right-click to add the scene to another object as a subset, please note that if you selected nothing as the target object, the scene will be added to the root object as a subset.

### Delete Object.

![](http://www.cocos2d-x.org/attachments/download/3047)

Deletes the selected object
\# If no object or only one object is selected, this menu item is masked.
\# If you delete an object which contains a subset, the subset will be deleted.

### Add Components

![](http://www.cocos2d-x.org/attachments/download/3039)

-   Sprite
    The Sprite component is a rendering component which is used to render png format image files.
-   Armature Component
    The Armature animation component is a rendering component which is used to render Armature animations. If you mount the Armature animation component, an empty object can be converted into an animation object.
-   Map Component
    The Map component is a rendering component which is used to render the tmx format map file. If you mount the map component, an empty object can be converted into a map object.
-   UI Componen
    The UI component is a rendering component which is used to render UI controls. If you mount the UI component, an empty object can be converted into an UI object.
-   Particle Component
    The Particle component is a rendering component which is used to render pliat format Particle files. If you mount the Particle component, an empty object can be converted into a Particle object.
    Custom Property The Custom Property component is used to load data from the json file.
-   Audio
    The Audio Component is used to play mp3 and wav format audio files.

**Note** :
\# An empty object can only mount one rendering component.
\# An empty object can only add an audio component and a Custom Property Component.

### Delete Component

![](http://www.cocos2d-x.org/attachments/download/3040)

Armature Component=\>Remove Armature Component
Map Component\>Remove Map Component
UI Component=\>Remove UI Component
Particle Component=\>Remove Particle Component
Custom Property =\>Remove Custom Property Component
Audio Component\>Remove Audio Component
Sprite Component=\>Remove Sprite Component

**Note** :
If the selected node does not contain a component, the component corresponding menu item will be shielded.

### Copy

![](http://www.cocos2d-x.org/attachments/download/3041)

1.  If no object is selected, the menu item will be masked.
2.  The keyboard shortcut Ctrl + C for multiple selection is also supported.

### Paste

![](http://www.cocos2d-x.org/attachments/download/3042)

1.  If the object is not copied, this menu item is masked.
2.  The pasting position varies according to the mouse position.
3.  When using the keyboard shortcut Ctrl + V to paste, the current position is the pasted object replication.

