Skeletal animation
==================

> version: Cocos2d-x v2.x
> update: {{lastupdated_at}}

{{toc}}

Skeletal animation vs. Sprite sheets
------------------------------------

You can creat animations using sprite sheets which is quick and easy. Until you realize your game needs lots of animations and the memory consumption goes way up as well as the time required to load all the data. Also, to limit the size, you need to limit yourself to a low FPS for the animation, which also means the animation doesnt look as smooth as youd like. This is where skeletal animation comes in.

Introducing Skeletal Animation
------------------------------

Skeletal animation is a technique in cocos2d-x animation in which a character is represented in two parts: a surface representation used to draw the character (called skin or mesh) and a hierarchical set of interconnected bones (called the skeleton or rig) used to animate (pose and keyframe) the mesh.
![](http://www.cocos2d-x.org/attachments/1606/Skeletal-Animation.jpg)

Cocos2d-x provides a way to have 2d skeletal animations in your applications. The process of skeletal animation may be a bit complicated to setup, but using them afterwards is easy, and there are some tools to simplify the process.

When using skeletal animation, the animation is composed of several bones which are connected to one another. Affecting a bone also affects all of its children. By composing different transformations on each bone, you obtain different poses for the skeleton.

Now, if you define keyframes with certain transformations for a point in time for each of the bones in the skeleton, you can interpolate between the keyframes to obtain a smooth transition and thus animate the skeleton.

In the attached code, I used a class named Transformation, which contains data about 2D transformations, like translation, rotation and scale. Then, a Keyframe is defined by a frame number and one such Transformation. A collection of Keyframes defines a KeyframeAnimation. Finally, a SkeletonAnimation is a collection of KeyframeAnimations, one for each bone in the skeleton.

Separately, you use a Skeleton, which keeps a list of Joints that define the hierarchy of bones in the skeleton. Different from sprite sheets,each bone is then assigned a certain texture, like the ones below:

![](http://www.cocos2d-x.org/attachments/1607/animated-grossini.png)

