Cocos2d-x
======

Cocos2d-x is an open source game engine under MIT license. It can be used to build games, apps and other cross platform GUI based interactive programs. 

Cocos2d-x allows developers to exploit their existing C++, Lua and Javascript knowledge for cross-platform deployment into iOS, Android, Windows Phone, Mac OS X, Windows Desktop and Linux, saving time, effort and cost. Cocos2d-x is fast, easy to use and loaded with powerful features.

Cocos2d-x has been widely used by individuals and enthusiasts as well as big companies. Nowadays, many of Cocos2d-x game dominate the Top Grossing Charts of the AppStore and Google Play, especially in China, South Korea and Japan. Engineers from Chukong, Google, Microsoft, ARM, Intel and BlackBerry are actively engaged in Cocos2d-x community. Big guys such as Zynga, Wooga, Glu, IGG, Big Fish Games, Fingersoft, Gamevil, GREE, DeNA, Konami, CJ E&M, NHN, LINE, Square Enix, Disney Mobile has been used Cocos2d-x to develop their games.

Our vision is to create a complete toolchain for developing multi-platform games from rapid prototyping to a finished high performing game.

## Main Features

* Scene Management
* 2D Graphics
 	* OpenGL ES 2.0 (mobile) / OpenGL 2.1 (desktop) based
	* Transitions between scenes
	* Sprites and Sprite Sheets
	* Effects: Lens, Ripple, Waves, Liquid, etc.
	* Transformation Actions: Move, Rotate, Scale, Fade, Tint, etc.
	* Composable actions: Sequence, Spawn, Repeat, Reverse
	* Ease Actions: Exp, Sin, Cubic, Elastic, etc.
	* Misc actions: CallFunc, OrbitCamera, Follow, Tween
	* Basic menus and buttons
	* Particle system
	* Skeleton Animations: Spine and Adobe DragonBone
	* Fonts:
		* Fast font rendering using Fixed and Variable width fonts
		* Support for .ttf fonts
	* Tile Map support: Orthogonal, Isometric and Hexagonal
	* Parallax scrolling
	* Motion Streak
	* Render To Texture
	* Touch/Accelerometer on mobile devices
	* Touch/Mouse/Keyboard on desktop
	* Sound Engine support (CocosDenshion library) based on OpenAL
	* Integrated Slow motion/Fast forward
	* Fast and compressed textures:
		* PVR compressed and uncompressed textures
		* ETC1 compressed textures, and more
	* Resolution Independence
* UI Widgets
 	* Horizontal and Vertical layout
	* Containers: ListView, PageView, ScrollView
	* Widgets: Button, CheckBox, LoadingBar, Slider, TextField
* Physics
	* Integrated Chipmunk2D inside
	* A easy-to-use object-orientated wrapper with body, contact, joint, shape concepts
* Audio
	* Sound effects
	* Background Music
* Network
	* HTTP with SSL
	* WebSocket API
	* XMLHttpRequest API
	
## Build Requirements

* Mac OS X 10.7+, Xcode 5.1+
* or Ubuntu 12.10+, CMake 2.6+
* or Windows 7+, VS 2012+
* Python 2.7.5
* NDK r9d is required to build Android games

## Runtime Requirements

* iOS 5.0+ for iPhone / iPad games
* Android 2.3+ for Android games
* Windows Phone 8+ for Windows Phone games
* OS X v10.6+ for Mac games
* Windows 7+ for Win games

## Supported Programming Languages

|           |Platforms| C++ | Lua | JavaScript |
|-----------|---------|-----|-----|------------|
|**Mobile** |  iOS    | ?  |  ?  |    ?       | 
|           | Android | ?  |  ?  |    ?       |
|           |  WP8    | ?  |  ?  |    ?       |
|**Desktop**| win32   | ?  |  ?  |    ?       |
|           | Mac OSX | ?  |  ?  |    ?       |

Note that Javascript bindings can't run on Windows Phone 8 as Mozilla has no announced plans to bring SpiderMonkey to the platform. C++ and Lua can run on all platforms above.

## Supported Editors

* Official Editors
	* [[CocoStudio]], official cocos2d-x world editor, supports Windows 7+ and Mac 10.9+
       * [[Cocos Code IDE]], official Lua & JavaScript coding and debugging IDE, based on eclipse. supports Windows 7+ and Mac 10.9+

* 3rd Party World Editors
    * [Level Helper & Sprite Helper](http://www.gamedevhelper.com/)
* Animation Editors
	* [Spine](http://esotericsoftware.com/) for flipbook and skeleton animations
	* [Dragon Bones](http://dragonbones.github.io/), a Flash plugin to export and run Flash animations
* Bitmap Font Tools
	* [Glyph Designer](http://71squared.com/en/glyphdesigner)
* Particle Editing Tools
	* [Particle Designer](http://71squared.com/particledesigner)
* Texture Atlas Tools
	* [Texture Packer](http://www.codeandweb.com/texturepacker) and [How to use it with Cocos2d-x](http://www.cocos2d-x.org/wiki/TexturePacker)
	* [Zwoptex](http://www.zwopple.com/zwoptex/)
* Tile map Editing Tools
	* [Tiled Map Editor](http://www.mapeditor.org/)

## Download

* Stable Version:  http://download.cocos2d-x.org/
* Edge Version: http://github.com/cocos2d/cocos2d-x/